config/routes.rb
require 'avalon/routing/can_constraint'

Rails.application.routes.draw do
  mount Samvera::Persona::Engine => '/'
  mount Blacklight::Engine => '/catalog'
  concern :searchable, Blacklight::Routes::Searchable.new
  concern :exportable, Blacklight::Routes::Exportable.new

  resource :catalog, only: [:index], as: 'catalog', path: '/catalog', controller: 'catalog' do
    concerns :searchable
  end

  # For some reason this needs to be after `resource :catalog` otherwise Blacklight will generate links to / instead of /catalog
  root to: "catalog#index"

  get '/mejs/:version', to: 'application#mejs'

  resources :solr_documents, only: [:show], path: '/catalog', controller: 'catalog' do
    concerns :exportable
  end

  resources :encode_records, only: [:show, :index] do
    collection do
      post :paged_index
      post :progress
    end
  end

  resources :bookmarks do
    concerns :exportable

    collection do
      delete 'clear'
      get 'delete'#, as: :delete_bookmarks
      post 'delete'
      get 'move'#, as: :move_bookmarks
      post 'move'
      get 'update_access_control'#, as: :update_access_control_bookmarks
      post 'update_access_control'
      post 'publish'#, as: :publish_bookmarks
      post 'unpublish'#, as: :unpublish_bookmarks
      get 'add_to_playlist'
      post 'add_to_playlist'
      get 'intercom_push'
      post 'intercom_push'
      get 'merge'
      post 'merge'
    end
  end

  devise_for :users, controllers: { omniauth_callbacks: 'users/omniauth_callbacks', sessions: 'users/sessions' }, format: false
  devise_scope :user do
    match '/users/auth/:provider', to: 'users/omniauth_callbacks#passthru', as: :user_omniauth_authorize, via: [:get, :post]
    Avalon::Authentication::Providers.collect { |provider| provider[:provider] }.uniq.each do |provider_name|
      match "/users/auth/#{provider_name}/callback", to: "users/omniauth_callbacks##{provider_name}", as: "user_omniauth_callback_#{provider_name}".to_sym, via: [:get, :post]
    end
  end

  mount BrowseEverything::Engine => '/browse'

  # Avalon routes
  match "/authorize", to: 'derivatives#authorize', via: [:get, :post]
  match "/authorize/:path", to: 'derivatives#authorize', via: [:get, :post]

  namespace :admin do
    resources :groups, except: [:show] do
      collection do
        put 'update_multiple'
      end
      member do
        put 'update_users'
      end
    end
    resources :collections do
      member do
        get 'edit'
        get 'remove'
        get 'items'
        get 'poster'
        post 'poster', action: :attach_poster, as: 'attach_poster'
        delete 'poster', action: :remove_poster, as: 'remove_poster'
      end
    end

    namespace :migration_report, controller: '/migration_status' do
      get '/', action: :index
      get ':class', action: :show, as: 'by_class'
      get ':id/detail', action: :detail, as: 'detail'
      get ':id/report', action: :report, as: 'report'
    end
  end

  resources :vocabulary, except: [:create, :destroy, :new, :edit]

  resources :collections, only: [:index, :show] do
    member do
      get :poster
    end
  end

  resources :media_objects, except: [:create, :update] do
    member do
      put :update, action: :update, defaults: { format: 'html' }, constraints: { format: 'html' }
      put :update, action: :json_update, constraints: { format: 'json' }
      patch :update, action: :update, defaults: { format: 'html' }, constraints: { format: 'html' }
      put :update_status
      get :progress, :action => :show_progress
      get 'content/:file', :action => :deliver_content, :as => :inspect
      get 'track/:part', :action => :show, :as => :indexed_section
      get 'section/:content', :action => :show, :as => :id_section
      get 'section/:content/stream', :action => :show_stream_details, :as => :section_stream
      get 'section/:content/embed', :to => redirect('/master_files/%{content}/embed')
      get 'tree', :action => :tree, :as => :tree
      get :confirm_remove
      get :add_to_playlist_form
      post :add_to_playlist
      patch :intercom_push
      get :manifest
      get :move_preview, defaults: { format: 'json' }, constraints: { format: 'json' }
    end
    collection do
      post :create, action: :create, constraints: { format: 'json' }
      post :set_session_quality
      get :confirm_remove
      put :update_status
      # 'delete' has special signifigance so use 'remove' for now
      delete :remove, :action => :destroy
      get :intercom_collections
    end

    # Supplemental Files
    resources :supplemental_files, except: [:new, :index, :edit]
  end

  resources :master_files, except: [:new, :index] do
    member do
      get  'thumbnail', :to => 'master_files#get_frame', :defaults => { :type => 'thumbnail' }
      get  'poster',    :to => 'master_files#get_frame', :defaults => { :type => 'poster' }

      post 'thumbnail', :to => 'master_files#set_frame', :defaults => { :type => 'thumbnail', :format => 'html' }
      post 'poster',    :to => 'master_files#set_frame', :defaults => { :type => 'poster', :format => 'html' }
      post 'still',     :to => 'master_files#set_frame', :defaults => { :format => 'html' }
      get :embed
      post 'attach_structure'
      post 'attach_captions'
      get :captions
      get :waveform
      match ':quality.m3u8', to: 'master_files#hls_manifest', via: [:get], as: :hls_manifest
      get 'structure', to: 'master_files#structure', constraints: { format: 'json' }
      post 'structure', to: 'master_files#set_structure', constraints: { format: 'json' }
      delete 'structure', to: 'master_files#delete_structure', constraints: { format: 'json' }
      post 'move'
    end

    # Supplemental Files
    resources :supplemental_files, except: [:new, :index, :edit]
  end

  match "iiif_auth_token/:id", to: 'master_files#iiif_auth_token', via: [:get], as: :iiif_auth_token

  resources :derivatives, only: [:create]
  match "/autocomplete", to: 'objects#autocomplete', via: [:get]
  match "/objects/:id", to: 'objects#show', via: [:get], :as => :objects
  match "/object/:id", to: 'objects#show', via: [:get]

  resources :playlists do
    resources :playlist_items, path: 'items', only: [:create, :update, :show] do
      get 'markers'
      get 'source_details'
      get 'related_items'
    end
    member do
      patch 'update_multiple'
      delete 'update_multiple'
      patch 'regenerate_access_token'
      get 'refresh_info'
    end
    collection do
      post 'duplicate'
      post 'paged_index'
      if Settings['variations'].present?
        post 'import_variations_playlist'
      end
    end
  end

  resources :avalon_marker, only: [:create, :show, :update, :destroy]

  resources :comments, only: [:index, :create]

  resources :playlist_items, only: [:update], :constraints => {:format => /(js|json)/}

  resources :timelines do
    member do
      patch 'regenerate_access_token'
      post 'manifest', to: 'timelines#manifest_update', constraints: { format: 'json' }
      get 'manifest', constraints: { format: 'json' }
    end
    collection do
      post 'duplicate'
      post 'paged_index'
      if Settings['variations'].present?
        post 'import_variations_timeline'
      end
    end
  end
  get '/timeliner', to: 'timelines#timeliner', as: :timeliner

  resources :dropbox, :only => [] do
    collection do
      delete :bulk_delete
    end
  end

  match "/oembed", to: 'master_files#oembed', via: [:get]

  constraints(Avalon::Routing::CanConstraint.new(:read, :about_page)) do
    mount AboutPage::Engine => '/about(.:format)', as: 'about_page'
  end
  get '/about(.:format)', to: redirect('/')
  get '/about/health.yaml', to: 'about_page/about#health', defaults: { :format => 'yaml' }
  get '/about/health(.:format)', to: redirect('/')

  constraints(Avalon::Routing::CanConstraint.new(:manage, :jobs)) do
    mount Sidekiq::Web, at: '/jobs', as: 'jobs'
  end
  get '/jobs(.:format)', to: redirect('/')
end

app/helpers/catalog_helper.rb
# Copyright 2011-2020, The Trustees of Indiana University and Northwestern
#   University.  Licensed under the Apache License, Version 2.0 (the "License");
#   you may not use this file except in compliance with the License.
#
# You may obtain a copy of the License at
#
# http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software distributed
#   under the License is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR
#   CONDITIONS OF ANY KIND, either express or implied. See the License for the
#   specific language governing permissions and limitations under the License.
# ---  END LICENSE_HEADER BLOCK  ---

module CatalogHelper
  include Blacklight::CatalogHelperBehavior

  def current_sort_field
    actualSort = @response.sort if (@response and @response.sort.present?)
    actualSort ||= params[:sort]
    blacklight_config.sort_fields[actualSort] || default_sort_field
  end

end

app/views/catalog/_document_list.html.erb
<%#
Copyright 2011-2020, The Trustees of Indiana University and Northwestern
  University.  Licensed under the Apache License, Version 2.0 (the "License");
  you may not use this file except in compliance with the License.

You may obtain a copy of the License at

http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software distributed
  under the License is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR
  CONDITIONS OF ANY KIND, either express or implied. See the License for the
  specific language governing permissions and limitations under the License.
---  END LICENSE_HEADER BLOCK  ---
%>
<% # container for all documents in index list view -%>
<div id="documents" class="documents-<%= document_index_view_type %>">
  <% if render_bookmarks_control? && documents.count>1 %> 
    <%= render "select_all" %>
  <% end %>
  <%= render documents, :as => :document %>
</div>

app/views/catalog/_facet_group.html.erb
<%#
Copyright 2011-2020, The Trustees of Indiana University and Northwestern
  University.  Licensed under the Apache License, Version 2.0 (the "License");
  you may not use this file except in compliance with the License.

You may obtain a copy of the License at

http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software distributed
  under the License is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR
  CONDITIONS OF ANY KIND, either express or implied. See the License for the
  specific language governing permissions and limitations under the License.
---  END LICENSE_HEADER BLOCK  ---
%>
<% # main container for facets/limits menu -%>
<% if has_facet_values? facet_field_names(groupname) %>
<div id="facets<%= "-#{groupname}" unless groupname.nil? %>" class="facets sidenav">

  <div class="top-panel-heading panel-heading">
    <button type="button" class="facets-toggle" data-toggle="collapse" data-target="#facet-panel<%= "-#{groupname}" unless groupname.nil? %>-collapse">
      <span class="sr-only">Toggle facets</span>
      <span class="icon-bar"></span>
      <span class="icon-bar"></span>
      <span class="icon-bar"></span>
    </button>

  <h2>
  	<%= groupname.blank? ? t('blacklight.search.facets.title') : t("blacklight.search.facets-#{groupname}.title", default: groupname.titleize) %>
  </h2>
    </div>

  <div id="facet-panel<%= "-#{groupname}" unless groupname.nil? %>-collapse" class="collapse panel-group">
  <%= render_facet_partials facet_field_names(groupname) %>
</div>
</div>
<% end %>

app/views/catalog/_facets.html.erb
<%#
Copyright 2011-2020, The Trustees of Indiana University and Northwestern
  University.  Licensed under the Apache License, Version 2.0 (the "License");
  you may not use this file except in compliance with the License.

You may obtain a copy of the License at

http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software distributed
  under the License is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR
  CONDITIONS OF ANY KIND, either express or implied. See the License for the
  specific language governing permissions and limitations under the License.
---  END LICENSE_HEADER BLOCK  ---
%>
<% facet_group_names.each do |groupname| %>
  <%= render partial: "facet_group", locals: {groupname: groupname} %>
<% end %>

app/views/catalog/_home_text.html.erb
<%#
Copyright 2011-2020, The Trustees of Indiana University and Northwestern
  University.  Licensed under the Apache License, Version 2.0 (the "License");
  you may not use this file except in compliance with the License.

You may obtain a copy of the License at

http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software distributed
  under the License is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR
  CONDITIONS OF ANY KIND, either express or implied. See the License for the
  specific language governing permissions and limitations under the License.
---  END LICENSE_HEADER BLOCK  ---
%>
<h2 id="featured_content_header">Sample Content</h2>
<div id="featured_content" class="row">
  <div class="col-md-4">
    <h4>Featured Collection</h4>
    <a href="#">
      <%= image_tag "Nutcracker-Ballet.png", alt: "Featured Collection" %>
    </a>
  </div>
  <div class="col-md-4">
    <h4>Featured Video</h4>
     <a href="#">
        <%= image_tag "Charlie-McCarthy.png", alt: "Featured Collection" %>
      </a>
  </div>
  <div class="col-md-4">
    <h4>Featured Audio</h4>
    <a href="#">
      <%= image_tag "Chucky-Lou.png", alt: "Featured Collection" %></a></li>
  </div>
</div>
<h4>Using the System</h4>

<p>Avalon houses audio and video collections. Use the search box, or browse using the terms on the left side to discover content. Some content is only available when you sign in.  Sign in with your ID and passphrase.</p>

app/views/catalog/_index_header_media_object.html.erb
<%#
Copyright 2011-2020, The Trustees of Indiana University and Northwestern
  University.  Licensed under the Apache License, Version 2.0 (the "License");
  you may not use this file except in compliance with the License.

You may obtain a copy of the License at

http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software distributed
  under the License is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR
  CONDITIONS OF ANY KIND, either express or implied. See the License for the
  specific language governing permissions and limitations under the License.
---  END LICENSE_HEADER BLOCK  ---
%>
<%# header bar for doc items in index view -%>
<div class="documentHeader row">
  <%# main title container for doc partial view
      How many bootstrap columns need to be reserved
      for bookmarks control depends on size.
  -%>
  <% document_actions = capture do %>
    <% # bookmark functions for items/docs -%>
    <%= render_index_doc_actions document, wrapping_class: "index-document-functions col-sm-3 col-lg-2" %>
  <% end %>

  <h3 class="index_title document-title-heading <%= document_actions.present? ? "col-sm-9 col-lg-10" : "col-md-12" %>">
    <% if counter = document_counter_with_offset(document_counter) %>
      <span class="document-counter">
        <%= t('blacklight.search.documents.counter', counter: counter) %>
      </span>
    <% end %>
    <%= link_to_document document, search_result_label(document), counter: counter %>
  </h3>

  <%= document_actions %>
</div>

app/views/catalog/_index_media_object.html.erb
<%#
Copyright 2011-2020, The Trustees of Indiana University and Northwestern
  University.  Licensed under the Apache License, Version 2.0 (the "License");
  you may not use this file except in compliance with the License.

You may obtain a copy of the License at

http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software distributed
  under the License is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR
  CONDITIONS OF ANY KIND, either express or implied. See the License for the
  specific language governing permissions and limitations under the License.
---  END LICENSE_HEADER BLOCK  ---
%>

<% doc_presenter = index_presenter(document) %> 
<%# default partial to display solr document fields in catalog index view -%>
<dl class="document-metadata dl-horizontal dl-invert col-md-9">
  
  <% index_fields(document).each do |field_name, field| -%>
    <% if should_render_index_field? document, field %>
	    <dt class="blacklight-<%= field_name.parameterize %>"><%= render_index_field_label document, field: field_name %></dt>
	    <dd class="blacklight-<%= field_name.parameterize %>"><%= doc_presenter.field_value field_name %></dd>
    <% end -%>
  <% end -%>

</dl>

app/views/catalog/_select_all.html.erb
<%#
Copyright 2011-2020, The Trustees of Indiana University and Northwestern
  University.  Licensed under the Apache License, Version 2.0 (the "License");
  you may not use this file except in compliance with the License.

You may obtain a copy of the License at

http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software distributed
  under the License is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR
  CONDITIONS OF ANY KIND, either express or implied. See the License for the
  specific language governing permissions and limitations under the License.
---  END LICENSE_HEADER BLOCK  ---
%>
<% # container for select_all bookmarks button -%>

<% if current_or_guest_user %>
  <div class="col-sm-3 col-sm-offset-9 col-lg-2 col-lg-offset-10">
      <% all_selected = @document_list.all? do |d|
           current_or_guest_user.bookmarks.where({document_id: d.id, document_type: blacklight_config.solr_document_model.to_s}).exists?
         end %>
      <%= check_box_tag('bookmarks_selectall', '', all_selected) %>
      <%= label_tag 'selectall', t('blacklight.bookmarks.addall.button') %>
  </div>
<% end %>

app/views/catalog/_thumbnail_media_object.html.erb
<%#
Copyright 2011-2020, The Trustees of Indiana University and Northwestern
  University.  Licensed under the Apache License, Version 2.0 (the "License");
  you may not use this file except in compliance with the License.

You may obtain a copy of the License at

http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software distributed
  under the License is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR
  CONDITIONS OF ANY KIND, either express or implied. See the License for the
  specific language governing permissions and limitations under the License.
---  END LICENSE_HEADER BLOCK  ---
%>

<div class="col-md-3">
  <% if image_url = image_for(document) %>
    <%= link_to(media_object_path(document[:id]), {class: 'result-thumbnail'}) do %>
      <%= image_tag( image_url ) %>
    <% end %>
  <% else %>
    <%= image_tag 'no_icon.png', class: 'result-thumbnail' %>
  <% end %>
</div>

app/views/catalog/index.html.erb
<%#
Copyright 2011-2020, The Trustees of Indiana University and Northwestern
  University.  Licensed under the Apache License, Version 2.0 (the "License");
  you may not use this file except in compliance with the License.

You may obtain a copy of the License at

http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software distributed
  under the License is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR
  CONDITIONS OF ANY KIND, either express or implied. See the License for the
  specific language governing permissions and limitations under the License.
---  END LICENSE_HEADER BLOCK  ---
%>
<% if current_page?(main_app.root_path) %>
<div class="homepage-splash-wrapper">
  <section class="homepage-splash-top-section">
    <div class="homepage-splash-search">
      <%= render :partial=>'modules/avalon_search_form' %>
    </div>

    <div class="homepage-splash-lead-copy">
      <div class="container">
        <p class="lead">Avalon Media System is an open source system for managing and providing access to large
          collections of
          digital audio and video.</p>
      </div>
    </div>
  </section>

  <% if @featured_collection.present? %>
  <section class="homepage-splash-featured-collection">
    <div>
      <%= image_tag poster_collection_url(@featured_collection.id), class: "homepage-featured-collection-image" %>
    </div>
    <div class="homepage-splash-featured-collection-content">
      <h3 class="serif-font">featured collection</h3>
      <h2><%= @featured_collection.name %></h2>
      <p><%= @featured_collection.description %></p>
      <a href="<%= collection_url(@featured_collection.id) %>" class="btn btn-default">View Collection</a>
    </div>
  </section>
  <% end %>

  <% if Settings.home_page&.carousel_collections&.present? %>
  <section class="homepage-splash-collections">
    <div class="container">
      <h3 class="homepage-splash-collections-title serif-font"><a href="<%= collections_url %>">view all collections</a>
      </h3>
    </div>
    <div class="container-fluid">
      <%= react_component("CollectionCarousel", { baseUrl: collections_url(format: :json, only: :carousel, limit: 10) }) %>
    </div>
  </section>
  <% end %>
</div>
<% else %>
<div id="sidebar" class="<%= sidebar_classes %>">
  <%= render 'search_sidebar' %>
</div>

<div id="content" class="<%= main_content_classes %>">
  <%= render 'search_results' %>
</div>
<% end %>